/* qcgi.cc - source file of qcgi class 
 * (c) Copyright Horace Chan, 1997
 * All Rights Reserved
 *  
 * This source code was developed for use at my website
 * http://www.csclub.uwaterloo.ca/~yhchan
 *
 * This program may be used and modified free of charge by anyone as
 * long as proper credits is given. By using this code you agree
 * to indemnify Horace Chan from any liability that might arise from
 * it's use.                                                   
 *								     
 * Selling the code for this program without prior written consent
 * is expressly forbidden.  In other words, please ask first before
 * you try and make money off of my program.						     
 *                                                                            
 * Obtain permission before redistributing this software over the
 * Internet or in any other medium.	In all cases copyright and header
 * must remain intact 
 *
 */ 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <time.h>
#include "qcgi.h"

qcgi::qcgi()
{
  int i, con_len, con_pos;
  char *con_line;
  
  entry_num = 0;
	
  if(strcmp(getenv("REQUEST_METHOD"),"POST")==0)
  { con_len = atoi(getenv("CONTENT_LENGTH"));
    con_line = fetch_content(stdin, &con_len);
  }
  else if (strcmp(getenv("REQUEST_METHOD"),"GET")==0)
    con_line = getenv("QUERY_STRING");
  else
    con_line = NULL;

	if(con_line == NULL)
		return;

	printf("con_line: %s\n",con_line);

	for (i=0; i < strlen(con_line); i++)
		if (con_line[i] == '=')
			entry_num++;

	printf("entry number: %d\n", entry_num);

	data = new entry[entry_num];

	for (i=0; i<entry_num; i++)
	{
    data[i].name = getword(con_line, '=');
		data[i].val = getword(con_line, '&');
		plustospace(data[i].val);
		unescape_url(data[i].val);
  }
}

void qcgi::start_html()
{ printf("Content-type: text/html\n\n"); }
 
int qcgi::get_entry_num()
{ return entry_num; }

char *qcgi::get_entry_name(int pos)
{	return data[pos].name; }

char *qcgi::get_entry_val(int pos)
{ return data[pos].val; }

int qcgi::get_int_entry_val(int pos)
{	return atoi(data[pos].val); }

char *qcgi::get_entry_val(char *name)
{
	int i;
	for (i=0; i<entry_num; i++)
	{
		if (strcmp(data[i].name, name) == 0)
			return data[i].val;
	}
	return "\0";
}

int qcgi::get_int_entry_val(char *name)
{
	int i;
	for (i=0; i<entry_num; i++)
	{
		if (strcmp(data[i].name, name) == 0)
			return atoi(data[i].val);
	}
	return 0;
}

char *qcgi::get_time()
{
	struct timeb tp;
  time_t t;
  
	ftime(&tp);  
  t = tp.time; 
	return ctime(&t);
}

char *qcgi::get_http_referer()
{	return getenv("HTTP_REFERER"); }

char *qcgi::get_http_user_agent()
{ return getenv("HTTP_USER_AGENT"); }

char *qcgi::get_remote_address()
{	return getenv("REMOTE_ADDR"); }

char *qcgi::get_remote_host()
{ return getenv("REMOTE_HOST"); }

/* Untility functions */
char *qcgi::fetch_content(FILE *f, int *con_len)
{
    int sztemp_size;
    char *sztemp;
    int pos;

    sztemp_size = 10240;
    pos = 0;
    sztemp = (char *) malloc(sizeof(char) * (sztemp_size + 1));

    while((!(feof(f))) && (*con_len))
    {
        sztemp[pos] = (char)fgetc(f);
        if(pos==sztemp_size)
        {   sztemp[pos+1] = '\0';
            sztemp_size *= 2;
            sztemp = (char *)realloc(sztemp,sizeof(char)*(sztemp_size+1));
        }
        (*con_len)--;
        pos++;
    }
    sztemp[pos+1] = '\0';
    return sztemp;
}

char *qcgi::getword(char *sztemp, char stop)
{
    int i, start_pos;
    static int con_pos = 0;

    start_pos = con_pos;
    
    while ((sztemp[con_pos] != stop) && ((con_pos-start_pos) < strlen(&sztemp[start_pos])))
      con_pos++;
    
    sztemp[con_pos++] = '\0';
    return &sztemp[start_pos];
}

char qcgi::x2c(char *what)
{
    register char digit;

    digit = (what[0] >= 'A' ? ((what[0] & 0xdf) - 'A')+10 : (what[0] - '0'));
    digit *= 16;
    digit += (what[1] >= 'A' ? ((what[1] & 0xdf) - 'A')+10 : (what[1] - '0'));
    return(digit);
}

void qcgi::unescape_url(char *url)
{
    register int x,y;

    for(x=0,y=0;url[y];++x,++y) {
        if((url[x] = url[y]) == '%') {
            url[x] = x2c(&url[y+1]);
            y+=2;
        }
    }
    url[x] = '\0';
}

void qcgi::plustospace(char *str)
{
    register int x;

    for(x=0;str[x];x++) if(str[x] == '+') str[x] = ' ';
}






