/* qcgi.h - header file of qcgi class 
 * (c) Copyright Horace Chan, 1997
 * All Rights Reserved
 *  
 * This source code was developed for use at my website
 * http://www.csclub.uwaterloo.ca/~yhchan
 *
 * This program may be used and modified free of charge by anyone as
 * long as giving proper credits is given. By using this code you agree
 * to indemnify Horace Chan from any liability that might arise from
 * it's use.                                                   
 *								     
 * Selling the code for this program without prior written consent
 * is expressly forbidden.  In other words, please ask first before
 * you try and make money off of my program.						     
 *                                                                            
 * Obtain permission before redistributing this software over the
 * Internet or in any other medium.	In all cases copyright and header
 * must remain intact 
 *
 */ 

#ifndef _QCGI_H
#define _QCGI_H

#define LF 10
#define CR 13

/* define entry structure */
class entry
{
public:
  char *name;
  char *val;
};

/* define qcgi class */
class qcgi
{
public:
  qcgi();
  void start_html();
  int get_entry_num();
  char *get_entry_name(int pos);
  char *get_entry_val(int pos);
  char *get_entry_val(char *name);
  int get_int_entry_val(int pos);
  int get_int_entry_val(char *name);
  char *get_time();
	char *get_http_referer();
  char *get_http_user_agent();
  char *get_remote_address();
  char *get_remote_host();

protected:
  int entry_num;
  entry *data;
  char *fetch_content(FILE *f, int *cl);
  char x2c(char *what);
  void unescape_url(char *url);
  void plustospace(char *str);
  char *getword(char *line, char stop);
};

#endif /* _QCGI_H */
